import { relation } from './relation';
import { select, csv } from 'd3';

const canvas = document.getElementById('canvas');

const width = 960;
const height = 500;
const render = data => {
		
  var edges = [];
  
 for (var t = (data.length, 4), e = 1; e <= t; e++)
   edges.push({
    source: 0,
    target: e
  });
  
 for (var e = t + 1; e < data.length; e++) 
   edges.push({
      source: e % t + 1,
      target: e
  });
  
  initColor(data);
  initRadius(data);
  
  var s = new relation;
  s.setNodes(data);
  s.setLinks(edges);
  s.setCanvas(canvas);
  s.setRadius(12);
  s.setSize(width, height);
  s.setLinkLength(90);
  s.setCharge(-60);
  s.init();
  s.run();
};

const initColor = data => {

  data[0].color = "#007FFF"; 
  data[1].color = "#A142FF"; 
  data[2].color = "#FF85C2"; 
  data[3].color = "#FFA142"; 
  data[4].color = "#FF4242";
  for (var index = 5; index < data.length; index++) {
    var t = d3.color(data[index % 4 + 1].color);
    data[index].color = t.brighter(1.5).toString()
  }
};

const initRadius = data => {
	data[0].radius = 18;
  data[1].radius = 14;
  data[2].radius = 14;
  data[3].radius = 14;
  data[4].radius = 14;
	for (var index = 5; index < data.length; index++) 
    data[index].radius = 10
};

csv('nodes.csv').then(data => {
  data.forEach(d => {
    d.id = +d.id;
  });
	console.log(data);
  render(data);
});

